#if !defined(_CO_COMMON_H)
#define _CO_COMMON_H

namespace CO_common {
  
  class Cmdl_parser {
  public:
    // what is stored in data:
    enum Cmdl_type {
      CLT_INT,  // int
      CLT_FLOAT, // float
      CLT_STR,   // string
      CLT_BOOL   // bool
    };

    /** union of possible values  */
    union Opt_data {
      int *i;
      bool *b;
      float *f;
      string *s;
    };
    
    struct Cmdl_data {
      string help;         // description of option
      Cmdl_type type;      // what will be stored in var
      Opt_data data;       // add to var we'll set      
      Cmdl_data(const string &h, Cmdl_type t):
	help(h), type(t) {}
      ~Cmdl_data() {}
    };

    typedef map<string, Cmdl_data, less<string> > Opt_map;

    Cmdl_parser(int argc, char **argv);
    ~Cmdl_parser() {}
    void add_opt(const string &h, const string &p, string *s);
    void add_opt(const string &h, const string &p, bool *b);
    void add_opt(const string &h, const string &p,  int *v);
    void add_opt(const string &h, const string &p, float *f);
    bool process_cmdl();
    const string &get_arg(int i) { return arg[i]; }
    const string &prog_name()    { return arg[0]; }
    void remove_arg(int i);
    int num_args() { return arg.size(); }
    void print_options();
  private:
    bool process_this_arg(Vector<string>::iterator &it);
    /** returns true if c is a number */
    bool is_num(string &c) const;
    Vector<string> arg;
    Opt_map opt;

  };

    class app {
  protected:
    Cmdl_parser parser;
    virtual bool validate_cmdl() { return true; }
  public:
    app(int argc, char *argv[]): parser(argc, argv)  {}
    virtual ~app() {}
    virtual void add_cmdl_opts(){}
    virtual bool process_cmdline()
    {
      parser.process_cmdl();
      return validate_cmdl();
    }
  };

}

#endif /* _CO_COMMON_H */
