#ifndef FAP_FPREL_H
#define FAP_FPREL_H

#include "revpr.h"

/**Final path relinking implementation
  *@author Carlos A.S. Oliveira
  */

// true when control-c signaled
bool global_end_fap();

class FFinalPathRel : public FReversePathRel {
  bool fpr_started;
public: 
	FFinalPathRel(FAP_inst &i, int max_iter) :
	   FReversePathRel(i, max_iter), fpr_started(false) {}
	FFinalPathRel(FAP_inst &i, FAP_sol &s, int max_iter) :
	   FReversePathRel(i, s, max_iter), fpr_started(false) {}
	~FFinalPathRel() {}
  /** Execution an action at the end of GRASP iterations. */
  virtual void terminate();
  /** We don't want to stop with a time-over condition,
   * because final path relinking is always the last thing.
   * Instead, we must provide extra-time for it to run. */
  virtual bool stop_condition()
  { if (fpr_started) return end || global_end_fap();
    else return FGrasp::stop_condition(); }
};

#endif
