#if !defined(_FAP_IFORMAT_H)
#define _FAP_IFORMAT_H

#define match(token)  \
  do { to_match = token; \
    if (! read_token(token, is)){ \
      cerr << "error reading token in line " << __LINE__ << endl; \
      cerr.flush(); \
      goto error_match; \
    } \
  } while (0)

#define m(s) match(#s);

#define readi(n) \
  do { \
    if (!read_integer(&n, is)) { \
       cerr << "error reading integer in line " <<  __LINE__ << endl; \
       goto error_integer;\
    }\
 } while (0)
#define readf(n) if (!read_float(&n, is)) goto error_float
#define readw if (!read_word(ident, MAX_IDENT_SIZE, is)) goto error_ident

#define MAX_IDENT_SIZE 64
#define INITIAL_DEMAND_VEC_SIZE  512

typedef struct {
  int cell;
  char site[MAX_IDENT_SIZE+1];
  int demand;
} cell_desc;

typedef struct {
  int d;
  float co, ad;
} interf_desc;

#define cell_num(a) ((a)+1)

void eat_white_space(ifstream &is);
void eat_text(ifstream &is);
void print_next_token(ifstream &is);
int read_float(float *num, ifstream &is);
int read_integer(int *num, ifstream &is);
int read_word(char *w, int size, ifstream &is);
int read_token(char *token, ifstream &is);
char *get_str_copy(char *c, ifstream &is);
cell_desc *read_demand(int *n_cells, ifstream &is);
// void print_demand(cell_desc *d, int size);
interf_desc **id_new(int size);
void id_delete(interf_desc **a, int size);

#endif /* _FAP_IFORMAT_H */
