#include <iostream>

#include "inst.h"
#include "sol.h"
#include "fgrasp.h"
#include "lsearch.h"

FAP_sol *FLocal_search::solve()
{
  int n = 0;
  while (n < max_try && !stop_condition()) {
    if (improve()) n=0;
    else  n++;
  }
  return sol;
}

bool FLocal_search::improve()
{
  int initial_f, f, trans;
  int n = inst.num_trans(), nf = inst.num_freq();

  // first, find a transmitter, starting the search
  // at a random point
  trans = (rand() % n)+1;
  
  // test if there is a transmitter with unblocked channels
  for (; trans <= n && bc[trans].num_blocked() == n; trans++)
    /* empty */ ;

  // no transmitter was found, so randomly generate one.
  if (trans > n) {
    trans = (rand() % n)+1;
  }
  
  // now find a free channel
  initial_f = f = (rand() % nf) + 1;
  while (bc[trans].blocked(f)){
    f++;
    if (f > nf) f = 1;
    // this heapens only if all channels are blocked.
    // So, use random channel `inital_f'.
    if (f == initial_f) break;
  }

  // now, try to improve the solution using frequency `f' for
  // transmitter `trans'
  if (sol->change_freq_if_improves(trans, f)) {
    if (verbose()) (cout<<'.').flush();
    return true;
  } else {
    return false;
  }
}
