
#include "revpr.h"

/** Improves local search using reverse path relinking */
void FReversePathRel::local_search()
{
  FPathRel::local_search();
  if (elite_set.size() >= (unsigned int)ELITE_SET_SIZE)
    reverse_pr();
}

/** Do the real work of reverse path relinking */
void FReversePathRel::reverse_pr()
{
  // choose a solution in the elite_set
  FAP_sol s(get_elite_solution());
  do_path_relinking(*sol, s);
  if (s < *sol)
    *sol = s;
}
