#ifndef FAP_REVPR_H
#define FAP_REVPR_H

#include "pathrel.h"

/**This class implements reverse path relinking in the
 * GRASP for FAP.
 *@author Carlos A.S. Oliveira
 */

class FReversePathRel : public FPathRel  {
public: 
	FReversePathRel(FAP_inst &i, int max_iter) : 
	  FPathRel(i, max_iter) {}
	FReversePathRel(FAP_inst &i, FAP_sol &s, int max_iter) : 
	  FPathRel(i, s, max_iter) {}
	~FReversePathRel() {}
private: // Private methods
  /** Improves local search using reverse path relinking */
  virtual void local_search();
  /** Do the real work of reverse path relinking */
  void reverse_pr();
};

#endif
