#if !defined(FAP_REACGRASP_H)
#define FAP_REACGRASP_H

#include "fgrasp.h"

/**This is the implementation of a  Reactive Grasp for FAP
  *@author Carlos A.S. Oliveira
  */
class FReactGrasp : public FGrasp  {
  static const int ALPHA_VEC_SIZE;
  static const int UPDATE_ITERATIONS;
  Vector<double> probability;
  Vector<double> avg_val;
  Vector<int>    alpha_freq;
  Vector<double> q;
  int current_alpha;
  
  void update_avg();
  void update_alpha();
  void init_structures();
 public: 
	FReactGrasp(FAP_inst &i, int max_iter);
	FReactGrasp(FAP_inst &i, FAP_sol &s, int max_iter);
	~FReactGrasp();
  /** This method represents the main difference in the implementation of a reactive GRASP. */
  virtual int get_alpha();
  /** called at the end of each iteration if GRASP constructor.*/
  virtual void update();
  /** This constructor is modified to update the reactive GRASP data structures. */
  virtual void constructor(int alpha);
};

#endif /* FAP_REACGRASP_H */
