#if !defined(__SOLVER_H)
#define __SOLVER_H


bool global_end_fap();
bool time_is_over();

template <class T,class Sol>
class solver {
 protected:
  T &inst;
  Sol *sol;
  bool end;
 public:
  solver(T &f) : inst(f) , sol(new Sol(inst)), end(false),
    delete_sol(true) {}
  solver(T &f, Sol *s) : inst(f), sol(s), end(false),
    delete_sol(false) {}
  virtual ~solver() { if (delete_sol) delete sol; }
  // this returns a pointer to a solution. This pointer
  // can not be deleted. The solution it poits potentially
  // changes every time we run solve.
  virtual Sol *solve() = 0;
  virtual bool stop_condition()
  { return end || global_end_fap() || time_is_over(); }
 private:
  bool delete_sol;
};

#endif // __SOLVER_H
