#if !defined(_MY_VECT_H)
#define _MY_VECT_H

#include <vector>
#include <assert.h>

#define BOUNDS_CHECK

template<class T>
class Vector : public vector<T> {
  int is;
public:
  Vector() : vector<T>() ,is(0){}
  Vector(int i) : vector<T>(i), is(i) {}
  Vector(int i, int j) : vector<T>(i, j), is(i) {}
  T &operator[](unsigned int i) {
#if defined(BOUNDS_CHECK)
    if (!(i>=0 && i < size())) {
	     cerr << "bounds error. Size is " << size()
	          << " and index is " << i << " initial size: "
	          << is << endl;
	     assert(0);
	   }
#endif	
    return vector<T>::operator[](i);
  }
  const T &operator[](unsigned int i) const {
#if defined(BOUNDS_CHECK)
    if (!(i>=0 && i < size())) {
	     cerr << "bounds error. Size is " << size()
	          << " and index is " << i << " initial size: "
	          << is << endl;
	     assert(0);
	   }
#endif
    return vector<T>::operator[](i);
  }
};

#endif /* _MY_VECT_H */
